#define		CHECKED_BOX	"&#9746;"
#define		UNCHECKED_BOX	"&#9744;"
#define		TEMPLATE_NAME	"ScriptTemplate13D.htm"
#define		DIRECTIVE_WRAP	"%%%"
#define		ERR_OUT		"<P>Error creating template, cannot build 13D from CSV.</P>"
#define		DATA_ROWS	31

string build_template();

boolean is_checkbox(string field);

string build_template() { 

    int			rc;
    int			ix;
    string		data[][];
    string		item;
    string		directive;
    string		checkbox;			
    string		csv, file, template, output;
    
    csv = BrowseOpenFile("Select CSV Data File","*.csv|*.csv");
    rc = GetLastError();
    if (rc==ERROR_CANCEL){
      return ERR_OUT;
      }
    if (IsFile(csv)==false || FindInString(csv,".csv")<0){
      MessageBox('x',"Invalid File Selected, try a different file. Error:%0x",rc);
      return ERR_OUT;
      }
    
    data = CSVReadTable(csv);
    rc = GetLastError();
    if (IsError(rc)){
      MessageBox('x',"Cannot read selected file. Error: %0x",rc);
      return ERR_OUT;
      }
    
    if (ArrayGetAxisDepth(data)!=DATA_ROWS){
      MessageBox('x',"The selected CSV file is not properly formatted.");
      return ERR_OUT;
      }
    
    template = GetApplicationExecuteFolder();				
    template = AddPaths(template,"Templates\\"+ TEMPLATE_NAME);	
    output = FileToString(template);
    rc = GetLastError();
    if (IsError(rc)){
      MessageBox('x',"Cannot read file %s. Error: %0x",template,rc);
      return ERR_OUT;
      }
    
    for (ix = 0; ix<DATA_ROWS; ix++){
      directive = data[ix][0];
      item = ANSITextToXML(data[ix][1]);
      if (is_checkbox(directive)){
	if (MakeLowerCase(item) == "x"){
	  item = CHECKED_BOX;
	  }
	else{
	  item = UNCHECKED_BOX;
	  }
	}
      directive = DIRECTIVE_WRAP+directive+DIRECTIVE_WRAP;
      output = ReplaceInString(output, directive, item);
      }  
    return output;
    }

boolean is_checkbox(string field){
    
    int 		ix;
    string		checkboxes[];
    int			size;
    
    checkboxes[0] = "COVERCHECKBOX";
    checkboxes[1] = "TABLE2A";
    checkboxes[2] = "TABLE2B";
    checkboxes[3] = "TABLE5";
    checkboxes[4] = "TABLE12";
    
    size = ArrayGetAxisDepth(checkboxes);
    for (ix=0;ix<size;ix++){
      if (checkboxes[ix]==field){
        return true;
	}
      }
    return false;
    } 

int main(){
    string 		s1;
    
    s1 = build_template();
    StringToFile(s1,"P:\\TestFile.htm");
    }
